;; $Id: dbl1bmno.dsl,v 1.1.1.4 1998/10/02 01:22:07 rosalia Exp $
;;
;; This file is part of the Modular DocBook Stylesheet distribution.
;; See ../README or http://nwalsh.com/docbook/dsssl/
;;

;; ----------------------------- Localization -----------------------------

;; Norsk Bokm\U-00E5;l localization. (a-ring)
;; Translated by Stig S. Bakken, ssb@guardian.no
;; Send changes to Norman Walsh, ndw@nwalsh.com

;; The generated text for cross references to elements.  See dblink.dsl
;; for a discussion of how substitution is performed on the %x and #x
;; keywords.
;;

(define (gentext-bmno-xref-strings giname)
  (case giname
    (("APPENDIX") (if %chapter-autolabel%
		      "Tillegg %n"
		      "tillegget kalt %t"))
    (("ARTICLE") "\U-201C;%t\U-201D;")
    (("BOOK") "%t")
    (("CHAPTER") (if %chapter-autolabel%
		     "Kapittel %n"
		     "kapittelet kalt %t"))
    (("EQUATION") "Formel %n")
    (("EXAMPLE") "Eksempel %n")
    (("FIGURE") "Figur %n")
    (("INFORMALTABLE") "%kg %kn")
    (("LISTITEM") "%n")
    (("PART") "Del %n")
    (("PREFACE") "%t")
    (("PROCEDURE") "Prosedyre %n, %t")
    (("SECT1") (if %section-autolabel% 
		   "Seksjon %n" 
		   "seksjonen kalt %t#c"))
    (("SECT2") (if %section-autolabel% 
		   "Seksjon %n" 
		   "seksjonen kalt %t#c"))
    (("SECT3") (if %section-autolabel% 
		   "Seksjon %n" 
		   "seksjonen kalt %t#c"))
    (("SECT4") (if %section-autolabel% 
		   "Seksjon %n" 
		   "seksjonen kalt %t#c"))
    (("SECT5") (if %section-autolabel% 
		   "Seksjon %n" 
		   "seksjonen kalt %t#c"))
    (("STEP") "steg %n#k")
    (("TABLE") "Tabell %n")
    (("TITLE") "%kg %kn")
    (else (string-append "[xref til " 
			 (if giname 
			     giname
			     "ikke-eksisterende element")
			 " ikke st&oslash;ttet]"))))

;; Indirection in the generated text for cross references.  The first
;; element of the list is used for cross references across element
;; boundries, the second element is used for cross references within
;; the same element
;;
(define (gentext-bmno-xref-strings-indirect key)
  (case key
    (("b") '("" ""))
    (("c") '(" i %cg %cn" ""))
    (("d") '("" ""))
    (("k") '(" i %kg %kn" ""))
    (("s") '("" ""))))

;; Should the TOC come first or last?
;;
(define %generate-bmno-toc-in-front% #t)

;; gentext-bmno-element-name returns the generated text that should be 
;; used to make reference to the selected element.
;;
(define (gentext-bmno-element-name giname)
  (case giname
    (("ABSTRACT") "Abstract")
    (("APPENDIX") "Tillegg")
    (("BIBLIOGRAPHY") "Bibliografi")
    (("CAUTION") "OBS")
    (("CHAPTER") "Kapittel")
    (("COPYRIGHT") "Copyright")
    (("DEDICATION") "Dedikasjon")
    (("EQUATION") "Formel")
    (("EXAMPLE") "Eksempel")
    (("FIGURE") "Figur")
    (("GLOSSARY") "Ordliste")
    (("GLOSSSEE") "Se")
    (("GLOSSSEEALSO") "Se Ogs&aring;")
    (("IMPORTANT") "VIKTIG")
    (("INDEX") "Indeks")
    (("LEGALNOTICE") "")
    (("MSGAUD") "Publikum")
    (("MSGLEVEL") "Niv&aring;")
    (("MSGORIG") "Opphav")
    (("NOTE") "NOTAT")
    (("PART") "Del")
    (("PREFACE") "Forord")
    (("PROCEDURE") "Prosedyre")
    (("REFERENCE") "Referanse")
    (("REFNAME") "Navn")
    (("REVHISTORY") "Revisjonshistorie")
    (("REVISION") "Revisjon")
    (("SECT1") "Seksjon")
    (("SECT2") "Seksjon")
    (("SECT3") "Seksjon")
    (("SECT4") "Seksjon")
    (("SECT5") "Seksjon")
    (("SIDEBAR") "")
    (("STEP") "steg")
    (("TABLE") "Tabell")
    (("TIP") "TIPS")
    (("TOC") "Innholdsfortegnelse")
    (("WARNING") "ADVARSEL")
    (else (string-append "UVENTET-ELEMENTNAVN: " giname))))

;; gentext-bmno-element-name-space returns gentext-bmno-element-name with a 
;; trailing space, if gentext-bmno-element-name isn't "".
;;
(define (gentext-bmno-element-name-space giname)
  (string-with-space (gentext-bmno-element-name giname)))

;; gentext-bmno-intra-label-sep returns the seperator to be inserted
;; between multiple occurances of a label (or parts of a label)
;; for the specified element.  Most of these are for enumerated
;; labels like "Figure 2-4", but this function is used elsewhere
;; (e.g. REFNAME) with a little abuse.
;;
(define (gentext-bmno-intra-label-sep giname)
  (case giname
    (("EQUATION") "-")
    (("EXAMPLE") "-")
    (("FIGURE") "-")
    (("PROCEDURE") ".")
    (("REFENTRY") ".")
    (("REFERENCE") ".")
    (("REFNAME") ", ")
    (("REFSECT1") ".")
    (("REFSECT2") ".")
    (("REFSECT3") ".")
    (("SECT1") ".")
    (("SECT2") ".")
    (("SECT3") ".")
    (("SECT4") ".")
    (("SECT5") ".")
    (("STEP") ".")
    (("TABLE") "-")
    (("_PAGENUMBER") "-")  ;; page number psuedo element
    (else "")))

;; gentext-bmno-label-title-sep returns the seperator to be inserted
;; between a label and the text following the label for the
;; specified element.  Most of these are for use between
;; enumerated labels and titles like "1. Chapter One Title", but
;; this function is used elsewhere (e.g. NOTE) with a little
;; abuse.
;;
(define (gentext-bmno-label-title-sep giname)
  (case giname
    (("ABSTRACT") ": ")
    (("APPENDIX") ". ")
    (("CAUTION") "")
    (("CHAPTER") ". ")
    (("EQUATION") ". ")
    (("EXAMPLE") ". ")
    (("FIGURE") ". ")
    (("FOOTNOTE") ". ")
    (("GLOSSSEE") ": ")
    (("GLOSSSEEALSO") ": ")
    (("IMPORTANT") ": ")
    (("NOTE") ": ")
    (("ORDEREDLIST") ". ")
    (("PART") ". ")
    (("PROCEDURE") ". ")
    (("PREFIX") ". ")
    (("REFENTRY") "")
    (("REFERENCE") ". ")
    (("REFSECT1") ". ")
    (("REFSECT2") ". ")
    (("REFSECT3") ". ")
    (("SECT1") ". ")
    (("SECT2") ". ")
    (("SECT3") ". ")
    (("SECT4") ". ")
    (("SECT5") ". ")
    (("STEP") ". ")
    (("TABLE") ". ")
    (("TIP") ": ")
    (("WARNING") "")
    (else "")))

(define (bmno-set-label-number-format gind) "1")
(define (bmno-book-label-number-format gind) "1")
(define (bmno-prefix-label-number-format gind) "1")
(define (bmno-part-label-number-format gind) "I")
(define (bmno-chapter-label-number-format gind) "1")
(define (bmno-appendix-label-number-format gind) "A")
(define (bmno-reference-label-number-format gind) "I")
(define (bmno-example-label-number-format gind) "1")
(define (bmno-figure-label-number-format gind) "1")
(define (bmno-table-label-number-format gind) "1")
(define (bmno-procedure-label-number-format gind) "1")
(define (bmno-step-label-number-format gind) "1")
(define (bmno-refsect1-label-number-format gind) "1")
(define (bmno-refsect2-label-number-format gind) "1")
(define (bmno-refsect3-label-number-format gind) "1")
(define (bmno-sect1-label-number-format gind) "1")
(define (bmno-sect2-label-number-format gind) "1")
(define (bmno-sect3-label-number-format gind) "1")
(define (bmno-sect4-label-number-format gind) "1")
(define (bmno-sect5-label-number-format gind) "1")
(define (bmno-default-label-number-format gind) "1")

(define (bmno-label-number-format gind)
  (let* ((giname (if (string? gind) gind (gi gind)))
	 (name   (normalize giname)))
    (cond
     ((equal? name (normalize "set")) (bmno-set-label-number-format gind))
     ((equal? name (normalize "book")) (bmno-book-label-number-format gind))
     ((equal? name (normalize "prefix")) (bmno-prefix-label-number-format gind))
     ((equal? name (normalize "part")) (bmno-part-label-number-format gind))
     ((equal? name (normalize "chapter")) (bmno-chapter-label-number-format gind))
     ((equal? name (normalize "appendix")) (bmno-appendix-label-number-format gind))
     ((equal? name (normalize "reference")) (bmno-reference-label-number-format gind))
     ((equal? name (normalize "example")) (bmno-example-label-number-format gind))
     ((equal? name (normalize "figure")) (bmno-figure-label-number-format gind))
     ((equal? name (normalize "table")) (bmno-table-label-number-format gind))
     ((equal? name (normalize "procedure")) (bmno-procedure-label-number-format gind))
     ((equal? name (normalize "step")) (bmno-step-label-number-format gind))
     ((equal? name (normalize "refsect1")) (bmno-refsect1-label-number-format gind))
     ((equal? name (normalize "refsect2")) (bmno-refsect2-label-number-format gind))
     ((equal? name (normalize "refsect3")) (bmno-refsect3-label-number-format gind))
     ((equal? name (normalize "sect1")) (bmno-sect1-label-number-format gind))
     ((equal? name (normalize "sect2")) (bmno-sect2-label-number-format gind))
     ((equal? name (normalize "sect3")) (bmno-sect3-label-number-format gind))
     ((equal? name (normalize "sect4")) (bmno-sect4-label-number-format gind))
     ((equal? name (normalize "sect5")) (bmno-sect5-label-number-format gind))
     (else ((bmno-default-label-number-format gind) gind)))))

(define ($lot-title-bmno$ lotgi)
  (cond ((string=? "TABLE"   lotgi) "Tabelloversikt")
	((string=? "EXAMPLE" lotgi) "Eksempeloversikt")
	((string=? "FIGURE"  lotgi) "Figuroversikt")
	((string=? "EQUATION" lotgi) "Formeloversikt")
	(else "???-oversikt")))

(define %gentext-bmno-start-quote%  (dingbat "ldquo"))

(define %gentext-bmno-end-quote%  (dingbat "rdquo"))

(define %gentext-bmno-by% "av") ;; e.g. Copyright 1997 "by" A. Nonymous
                           ;; Authored "by" Jane Doe

(define %gentext-bmno-edited-by% "Redigert av")
                           ;; "Edited by" Jane Doe

(define %gentext-bmno-page% "")

(define %gentext-bmno-and% "og")

(define %gentext-bmno-bibl-pages% "Sdr.")

(define %gentext-bmno-endnotes% "Sluttnotater")

(define %gentext-bmno-table-endnotes% "Notater:")

(define %gentext-bmno-index-see% "See")

(define %gentext-bmno-index-seealso% "See Also")
