;; $Id: dbl1pl.dsl,v 1.1.1.1 1998/10/02 01:22:13 rosalia Exp $
;;
;; This file is part of the Modular DocBook Stylesheet distribution.
;; See ../README or http://nwalsh.com/docbook/dsssl/
;;

;; ----------------------------- Localization -----------------------------

;; Polish localization.

;; If you create a new version of this file, please send it to
;; Norman Walsh, ndw@nwalsh.com

;; The generated text for cross references to elements.  See dblink.dsl
;; for a discussion of how substitution is performed on the %x and #x
;; keywords.
;;

(define (gentext-pl-xref-strings giname)
  (case giname
    (("APPENDIX") (if %chapter-autolabel%
		      "Dodatek %n"
		      "dodatek %t"))
    (("ARTICLE") (string-append %gentext-pl-start-quote%
				"%t"
				%gentext-pl-end-quote%))
    (("BIBLIOGRAPHY") "%t")
    (("BOOK") "%t")
    (("CHAPTER") (if %chapter-autolabel%
		     "Rozdzia&#179; %n"
		     "rozdzia&#179; %t"))
    (("EQUATION") "R&#243;wnanie %n")
    (("EXAMPLE") "Przyk&#179;ad %n")
    (("FIGURE") "Rysunek %n")
    (("INFORMALTABLE") "%kg %kn")
    (("LISTITEM") "%n")
    (("PART") "Cz&#234;&#182;&#230; %n")
    (("PREFACE") "%t")
    (("PROCEDURE") "Procedura %n, %t")
    (("SECT1") (if %section-autolabel% 
		   "Sekcja %n" 
		   "sekcja %t#c"))
    (("SECT2") (if %section-autolabel% 
		   "Sekcja %n" 
		   "sekcja %t#c"))
    (("SECT3") (if %section-autolabel% 
		   "Sekcja %n" 
		   "sekcja %t#c"))
    (("SECT4") (if %section-autolabel% 
		   "Sekcja %n" 
		   "sekcja %t#c"))
    (("SECT5") (if %section-autolabel% 
		   "Sekcja %n" 
		   "sekcja %t#c"))
    (("STEP") "krok %n#k")
    (("TABLE") "Tabela %n")
    (("TITLE") "%kg %kn")
    (else (string-append "[xref to " 
			 (if giname 
			     giname
			     "nie istniej&#177;cy element")
			 " nie wspierany]"))))

;; Indirection in the generated text for cross references.  The first
;; element of the list is used for cross references across element
;; boundries, the second element is used for cross references within
;; the same element
;;
(define (gentext-pl-xref-strings-indirect key)
  (case key
    (("b") '("" ""))
    (("c") '(" w %cg %cn" ""))
    (("d") '("" ""))
    (("k") '(" w %kg %kn" ""))
    (("s") '("" ""))))

;; Should the TOC come first or last?
;;
(define %generate-pl-toc-in-front% #t)

;; gentext-element-name returns the generated text that should be 
;; used to make reference to the selected element.
;;
(define (gentext-pl-element-name giname)
  (case giname
    (("ABSTRACT") "Abstrakt")
    (("APPENDIX") "Dodatek")
    (("BIBLIOGRAPHY") "Bibliografia")
    (("CAUTION") "PRZYPADEK")
    (("CHAPTER") "Rozdzia&#179;")
    (("COPYRIGHT") "Copyright")
    (("DEDICATION") "Dedykacja")
    (("EDITION") "Wydanie")
    (("EQUATION") "R&#243;wnanie")
    (("EXAMPLE") "Przyk&#179;ad")
    (("FIGURE") "Rysunek")
    (("GLOSSARY") "Glossary")
    (("GLOSSSEE") "Patrz")
    (("GLOSSSEEALSO") "Patrz te&#191;")
    (("IMPORTANT") "WA&#175;NE")
    (("INDEX") "Indeks")
    (("ISBN") "ISBN")
    (("LEGALNOTICE") "")
    (("MSGAUD") "Odbiorcy")
    (("MSGLEVEL") "Poziom")
    (("MSGORIG") "Nadawca")
    (("NOTE") "NOTATKA")
    (("PART") "Cz&#234;&#182;&#230;")
    (("PREFACE") "Przedmowa")
    (("PROCEDURE") "Procedura")
    (("PUBDATE") "Data wydania")
    (("REFERENCE") "Materia&#179;y &#188;r&#243;d&#179;owe")
    (("REFNAME") "Nazwa")
    (("REVHISTORY") "Historia zmian")
    (("REVISION") "Zmiana")
    (("SECT1") "Sekcja")
    (("SECT2") "Sekcja")
    (("SECT3") "Sekcja")
    (("SECT4") "Sekcja")
    (("SECT5") "Sekcja")
    (("SIDEBAR") "")
    (("STEP") "krok")
    (("TABLE") "Tabela")
    (("TIP") "Podpowied&#188;")
    (("TOC") "Spis tre&#182;ci")
    (("WARNING") "Ostrze&#191;enie")
    (else (string-append "UNEXPECTED-ELEMENT-NAME: " giname))))

;; gentext-element-name-space returns gentext-element-name with a 
;; trailing space, if gentext-element-name isn't "".
;;
(define (gentext-pl-element-name-space giname)
  (string-with-space (gentext-element-name giname)))

;; gentext-intra-label-sep returns the seperator to be inserted
;; between multiple occurances of a label (or parts of a label)
;; for the specified element.  Most of these are for enumerated
;; labels like "Figure 2-4", but this function is used elsewhere
;; (e.g. REFNAME) with a little abuse.
;;
(define (gentext-pl-intra-label-sep giname)
  (case giname
    (("EQUATION") "-")
    (("EXAMPLE") "-")
    (("FIGURE") "-")
    (("PROCEDURE") ".")
    (("REFENTRY") ".")
    (("REFERENCE") ".")
    (("REFNAME") ", ")
    (("REFSECT1") ".")
    (("REFSECT2") ".")
    (("REFSECT3") ".")
    (("SECT1") ".")
    (("SECT2") ".")
    (("SECT3") ".")
    (("SECT4") ".")
    (("SECT5") ".")
    (("STEP") ".")
    (("TABLE") "-")
    (("_PAGENUMBER") "-")  ;; page number psuedo element
    (else "")))

;; gentext-label-title-sep returns the seperator to be inserted
;; between a label and the text following the label for the
;; specified element.  Most of these are for use between
;; enumerated labels and titles like "1. Chapter One Title", but
;; this function is used elsewhere (e.g. NOTE) with a little
;; abuse.
;;
(define (gentext-pl-label-title-sep giname)
  (case giname
    (("ABSTRACT") ": ")
    (("APPENDIX") ". ")
    (("CAUTION") "")
    (("CHAPTER") ". ")
    (("EQUATION") ". ")
    (("EXAMPLE") ". ")
    (("FIGURE") ". ")
    (("FOOTNOTE") ". ")
    (("GLOSSSEE") ": ")
    (("GLOSSSEEALSO") ": ")
    (("IMPORTANT") ": ")
    (("NOTE") ": ")
    (("ORDEREDLIST") ". ")
    (("PART") ". ")
    (("PROCEDURE") ". ")
    (("PREFIX") ". ")
    (("REFENTRY") "")
    (("REFERENCE") ". ")
    (("REFSECT1") ". ")
    (("REFSECT2") ". ")
    (("REFSECT3") ". ")
    (("SECT1") ". ")
    (("SECT2") ". ")
    (("SECT3") ". ")
    (("SECT4") ". ")
    (("SECT5") ". ")
    (("STEP") ". ")
    (("TABLE") ". ")
    (("TIP") ": ")
    (("WARNING") "")
    (else "")))

(define (pl-set-label-number-format gind) "1")
(define (pl-book-label-number-format gind) "1")
(define (pl-prefix-label-number-format gind) "1")
(define (pl-part-label-number-format gind) "I")
(define (pl-chapter-label-number-format gind) "1")
(define (pl-appendix-label-number-format gind) "A")
(define (pl-reference-label-number-format gind) "I")
(define (pl-example-label-number-format gind) "1")
(define (pl-figure-label-number-format gind) "1")
(define (pl-table-label-number-format gind) "1")
(define (pl-procedure-label-number-format gind) "1")
(define (pl-step-label-number-format gind) "1")
(define (pl-refsect1-label-number-format gind) "1")
(define (pl-refsect2-label-number-format gind) "1")
(define (pl-refsect3-label-number-format gind) "1")
(define (pl-sect1-label-number-format gind) "1")
(define (pl-sect2-label-number-format gind) "1")
(define (pl-sect3-label-number-format gind) "1")
(define (pl-sect4-label-number-format gind) "1")
(define (pl-sect5-label-number-format gind) "1")
(define (pl-default-label-number-format gind) "1")

(define (pl-label-number-format gind)
  (let* ((giname (if (string? gind) gind (gi gind)))
	 (name   (normalize giname)))
    (cond
     ((equal? name (normalize "set")) (pl-set-label-number-format gind))
     ((equal? name (normalize "book")) (pl-book-label-number-format gind))
     ((equal? name (normalize "prefix")) (pl-prefix-label-number-format gind))
     ((equal? name (normalize "part")) (pl-part-label-number-format gind))
     ((equal? name (normalize "chapter")) (pl-chapter-label-number-format gind))
     ((equal? name (normalize "appendix")) (pl-appendix-label-number-format gind))
     ((equal? name (normalize "reference")) (pl-reference-label-number-format gind))
     ((equal? name (normalize "example")) (pl-example-label-number-format gind))
     ((equal? name (normalize "figure")) (pl-figure-label-number-format gind))
     ((equal? name (normalize "table")) (pl-table-label-number-format gind))
     ((equal? name (normalize "procedure")) (pl-procedure-label-number-format gind))
     ((equal? name (normalize "step")) (pl-step-label-number-format gind))
     ((equal? name (normalize "refsect1")) (pl-refsect1-label-number-format gind))
     ((equal? name (normalize "refsect2")) (pl-refsect2-label-number-format gind))
     ((equal? name (normalize "refsect3")) (pl-refsect3-label-number-format gind))
     ((equal? name (normalize "sect1")) (pl-sect1-label-number-format gind))
     ((equal? name (normalize "sect2")) (pl-sect2-label-number-format gind))
     ((equal? name (normalize "sect3")) (pl-sect3-label-number-format gind))
     ((equal? name (normalize "sect4")) (pl-sect4-label-number-format gind))
     ((equal? name (normalize "sect5")) (pl-sect5-label-number-format gind))
     (else ((pl-default-label-number-format gind) gind)))))

(define ($lot-title-pl$ lotgi)
  (cond ((string=? "TABLE"   lotgi) "Spis tabel")
	((string=? "EXAMPLE" lotgi) "Spis przyk&#179;ad&#243;w")
	((string=? "FIGURE"  lotgi) "Spis rysunk&#243;w")
	((string=? "EQUATION" lotgi) "Spis r&#243;wna&#241;")
	(else "Spis ???")))

(define %gentext-pl-start-quote% (dingbat "ldquo"))

(define %gentext-pl-end-quote% (dingbat "rdquo"))

(define %gentext-pl-by% " ") ;; e.g. Copyright 1997 "by" A. Nonymous
                           ;; Authored "by" Jane Doe

(define %gentext-pl-edited-by% "Redakcja: ")
                           ;; "Edited by" Jane Doe

(define %gentext-pl-page% "")

(define %gentext-pl-and% " i ")

(define %gentext-pl-bibl-pages% "stron ")

(define %gentext-pl-endnotes% " Przypisy ")

(define %gentext-pl-table-endnotes% " Przypisy ")

(define %gentext-pl-index-see% "Patrz")

(define %gentext-pl-index-seealso% "Patrz te&#191;")

